<?php
ob_start("ob_gzhandler");
set_time_limit(0);  // no time limit to finish script!
require_once('config.php');

echo $html_begin;
echo "<b>Import new packs or update existing packs</b><br><b>Directory:</b>".$internal_path;

$import_btn = (!empty($_REQUEST['import_btn'])) ? $_REQUEST['import_btn'] : null;
$update_btn = (!empty($_REQUEST['update_btn'])) ? $_REQUEST['update_btn'] : null;
$pack_name = ($import_btn) ? $_REQUEST['sel_pack'] : $_REQUEST['sel_pack_upd'];  


$update_pack = false;
if ( (($import_btn) OR ($update_btn))  AND ($pack_name))
{ 
    $tid_start = getmicrotime();
    $total_entries    = 0;
    $imported_entries = 0;
    echo "<table border=1><th>Filename</th><th>Already located here</th><th>md5</th><th>In these packs</th>";
    $pack_name .= "/";  
    $path = $internal_path.$pack_name;   
    if (is_dir($path))
    {      
      $pack_exist = $DB->pack_name_exists($pack_name);
      if ( ($pack_exist<>0) AND ($pack_name<>'') )
      { 
        // Update existing pack!
        $update_pack = true;
        $pack_id = $pack_exist['pack_id'];
        traversedir($path,'');
        $DB->set_pack_files($total_entries, $pack_id);
        $redundant .= "</table>";
        echo "</table>";
        echo "<h3>Pack: $pack_name was succesfully updated!</h3>";
        echo "<b>Total imported files:".$imported_entries." out of ".$total_entries."</b><br>";
        $redundant_entries = $total_entries - $imported_entries;
        echo "Redundant files not included: ".$redundant_entries."<br>".$reduntant;
      }
      else
      {    
        // Import new pack
        $pack_id = $DB->add_pack($pack_name);
        traversedir($path,'');
        $DB->set_pack_files($total_entries, $pack_id);
        $redundant .= "</table>";
        echo "</table>";
        echo "<h3>Pack: $pack_name was succesfully imported!</h3>";
        echo "<b>Total imported files:".$imported_entries." out of ".$total_entries."</b><br>";
        $redundant_entries = $total_entries - $imported_entries;
        echo "Redundant files not included: ".$redundant_entries."<br>".$reduntant;
      }
    }
    else if($pack_name=='*/')
    {
      echo "<br><b>Please wait.... importing all packs!</b><br>";
      ob_flush();flush();sleep(1);

      $dir_list = scandir($internal_path); 
      ignorecasesort($dir_list);
      for ($i=0;$i<sizeOf($dir_list);$i++)
      {
        global $DB;
        global $path;
        global $pack_id;
        global $pack_name;
        global $imported_entries;
        
        $dir_entry = $dir_list[$i];
        if ($dir_entry != "." && $dir_entry != "..") 
        {
          if (is_dir($internal_path.$dir_entry)) 
          {
            if ($DB->pack_name_exists($dir_entry."/")==0)
            { 
              $pack_name = $dir_entry;  
              $imported_entries = 0;
              $total_entries    = 0;
              echo "Processing: ".$pack_name;
              ob_flush();flush();sleep(1);
              $pack_name .= "/";  
              $pack_id = $DB->add_pack($pack_name);
              $path = $internal_path.$pack_name;   
              traversedir($path,'');
              $DB->set_pack_files($total_entries, $pack_id);
            }
          }
        }  
      }
    }
    else
    {
      echo "<h3>not a valid dir $pack_name</h3>";  
    }
    $tid_slut = getmicrotime();
    echo "<p>Time spend on import: ".gmdate('H:i:s', ($tid_slut-$tid_start)), "<br><form action=$PHP_SELF><input type=submit value='Ok'></form><hr>"; 
 }
 else
 {
  $dir_list = scandir($internal_path); 
  ignorecasesort($dir_list);

    echo "<form name='form_add_pack' action='$PHP_SELF' method='post'>";
    echo "<select name='sel_pack'>";
    echo "<option disabled value=''>Choose pack to import</option>";
    echo "<option value='*'>* Import all *</option>";
    for ($i=0;$i<sizeOf($dir_list);$i++)
    {
      $dir_entry = $dir_list[$i];
      if ($dir_entry != "." && $dir_entry != "..") 
      {
        if (is_dir($internal_path.$dir_entry)) 
        {
          if ($DB->pack_name_exists($dir_entry."/")==0)
          { 
            echo "<option value=\"$dir_entry\">".$dir_entry."</option>";
          }
        }
      }  
     }
    echo "</select>";
    echo "<input type='submit' name='import_btn' value='Import'>";
    
    echo "&nbsp;&nbsp;&nbsp;<select name='sel_pack_upd'>";
    echo "<option disabled value=''>Choose pack to update</option>";
    for ($i=0;$i<sizeOf($dir_list);$i++)
    {
      $dir_entry = $dir_list[$i];
      if ($dir_entry != "." && $dir_entry != "..") 
      {
        if (is_dir($internal_path.$dir_entry)) 
        {
          if ($DB->pack_name_exists($dir_entry."/")<>0)
          { 
            echo "<option value=\"$dir_entry\">".$dir_entry."</option>";
          }
        }
      }  
     }
    echo "</select>";
    echo "<input type='submit' name='update_btn' value='Update'>";
    echo "<br><br></form>"; 
 }  
  
// ************************************************************************** 
 
  function replace_bad_chars($str)
  {
    $str = str_replace('"',' ',$str);
    $str = str_replace('\\',' ',$str);
    $str = str_replace(chr(20),' ',$str);
    return $str;
  }


  function searchzip($dir,$dir_entry, $md5hash)
  {
    global $DB;
    global $path;
    global $pack_id;
    global $pack_name;
    global $imported_entries;
    global $total_entries;
    global $internal_path;
   
    $zip = zip_open($path.$dir.$dir_entry);
    $Lext = array("d64", "d81", "t64", "lnx", "p00", "prg");
    if ($zip) {
    while ($zip_entry = zip_read($zip)) {
        flush();
        $file_name      = zip_entry_name($zip_entry);
        $file_extension = strtolower(substr(strrchr($file_name,"."),1));
        if (in_array($file_extension, $Lext))         
        {
          if(zip_entry_open($zip, $zip_entry, 'r'))
          {
            $file_size = zip_entry_filesize($zip_entry);
            $contents  = zip_entry_read($zip_entry, $file_size);
            $md5hash   = md5($contents);    
            zip_entry_close($zip_entry);         
            if (!$DB->disk_md5_exist($md5hash, false, null))
            {
              // extract file
              $fh = fopen($internal_path.$pack_name.$dir.$file_name, "w");
              fwrite($fh, $contents, $file_size);fclose($fh);
              $dir_entry = $file_name;
              $imported_entries += 1;
              switch($file_extension) 
              {
              case "d64": searchdisk($dir, $dir_entry, $md5hash); break;
              case "t64": searchtape($dir, $dir_entry, $md5hash); break;
              case "lnx": searchlnx($dir, $dir_entry, $md5hash);  break;
              case preg_match("#^p+[0-9]#", $file_extension)==true: searchPC64($dir, $dir_entry, $md5hash); break;
              case "prg": searchPRG($dir, $dir_entry, $md5hash);  break;
              case "d81": searchdisk81($dir, $dir_entry, $md5hash); break;
              case "crt": searchCRT($dir, $dir_entry, $md5hash);  break;              
              case "g64": searchG64($dir, $dir_entry, $md5hash);  break;                           
              case "tap": searchTAP($dir, $dir_entry, $md5hash);  break;              
              default: ; // do nothing!
              }  
            }
            else {$total_entries += 1;}
          }
        }
      }
    zip_close($zip);
    }  
  } 
 
  function searchdisk($dir,$dir_entry, $md5hash)
  {
    global $DB;
    global $path;
    global $pack_id;
    global $pack_name;
    global $imported_entries;
    
    $filename = $path.$dir.$dir_entry;
    $file_size = filesize($filename);
   if ( ($file_size==174848) OR ($file_size==175531) )
   {    
    $fp = fopen($filename,'r');
    fseek($fp,91521);    // = 256*21*17 + 1 = 91393 + header info! 91649
    $d64disklabel = fread($fp,32);
    $d64disklabel = substr($d64disklabel,15,16);
    $d64disklabel = replace_bad_chars($d64disklabel);

    $d64diskid = fread($fp,32); 
    $d64diskid = substr($d64diskid,1,5);
    $d64diskid = replace_bad_chars($d64diskid);

    $disk_id = $DB->add_disk($dir_entry, $d64disklabel.$d64diskid, $pack_name.$dir, $pack_id, $md5hash);
    fseek($fp,64,SEEK_CUR); 
    for($i=0;$i<144;$i++)
    {
      $entry = fread($fp,32);
      $track = ord(substr($entry,2,1));
      $sector = ord(substr($entry,3,1));
      //illegal track begins..  else 0/0 is default end of DIR
      if ( ($track>41)) {fclose($fp);return;}
           
      $c64_filetype = ord(substr($entry,1,1));
      switch ($c64_filetype) 
        {
          case 130: $c64_filetype = 'PRG';break; // $82             
          case 192: $c64_filetype = 'DEL';break; // 
          case 193: $c64_filetype = 'PRG';break; // 
          case 194: $c64_filetype = 'PRG';break; //            
          case 128: $c64_filetype = 'DEL';break; // $80
          case 129: $c64_filetype = 'SEQ';break; // $81
          case 131: $c64_filetype = 'USR';break; // $83
          case 132: $c64_filetype = 'REL';break; // $84
          case 0  : $c64_filetype = '*RM';break; // $00 Deleted file!
          default: $c64_filetype = 'UNK'; // Unknown              
        }
      if ($c64_filetype<>'UNK')
      {   
        $c64_filename = trim(substr($entry,4,16));
        $c64_filename = replace_bad_chars($c64_filename);
        if ($c64_filename<>'')
        {
            $file_size = ord(substr($entry,29,1));
            $DB->add_release($c64_filename, $c64_filetype, $file_size, $disk_id, null);
        } 
      }
    }
    fclose($fp);
   } // IF NOT BAD FILESIZE!
   else
   {    
    $imported_entries -= 1;
   }
  }


  // convert low, hi byte to hex        
  function lowhi2hex($low,$hi){
        if (strlen($low)==1) {$low = '0'.$low;}
        return hexdec($hi.$low);
        }

  function t64_filetype($value){
        switch ($value)
          {
            case "2"   : $t64type='*PRG' ; break;               
            case "129" : $t64type='SEQ' ; break;               
            case "130" : $t64type='PRG' ; break;               
            case "194" : $t64type='PRG<' ; break;               
            default    : $t64type='UNK'; 
          }
        return $t64type;
  }
  
  
  function searchtape($dir,$dir_entry, $md5hash)
  {
    global $DB;
    global $path;
    global $pack_id;
    global $pack_name;   
    $filename = $path.$dir.$dir_entry;
    $file_size = filesize($filename);
    $fp = fopen($filename,'r');
    $c64_image = fread($fp,$file_size);

    // verify that it is a C64S or C64 file
    if (substr($c64_image,0,3)<>'C64') return false;  

    $header = substr($c64_image,34,4);
    $s_hi = dechex(ord(substr($header,1,1)));
    $s_low  = dechex(ord(substr($header,2,1)));          
    $num_entries = hexdec(lowhi2hex($s_low,$s_hi));
    $c64_label = substr($c64_image,40,24);
    $c64_label = replace_bad_chars($c64_label);

    $disk_id = $DB->add_disk($dir_entry, $c64_label, $pack_name.$dir, $pack_id, $md5hash);
    for($i=0;$i<$num_entries;$i++)
            {
              $offset = (32*$i)+64;
              $entry = substr($c64_image,$offset,32);
              $c64_filetype = t64_filetype((ord(substr($entry,1,1))));
              
              $s_low = dechex(ord(substr($entry,2,1)));
              $s_hi  = dechex(ord(substr($entry,3,1)));
              $start = lowhi2hex($s_low,$s_hi);

              $e_low = dechex(ord(substr($entry,4,1)));
              $e_hi  = dechex(ord(substr($entry,5,1)));
              $end = lowhi2hex($e_low,$e_hi);

              $offset_low = dechex(ord(substr($entry,8,1)));
              $offset_hi  = dechex(ord(substr($entry,9,1)));
              $file_offset = lowhi2hex($offset_low,$offset_hi)+2; // +2 NEW!

              $c64_filename = substr($entry,16,32);
              $c64_filename = replace_bad_chars($c64_filename);
              $file_size    = ceil(($end-$start)/254);

          		$size = ($end-$start)+2;
			        $file_entry   = substr($c64_image, $file_offset, $end-$start+2);
              
              $file_entry_md5 = md5($file_entry);
              $DB->add_release($c64_filename, $c64_filetype, $file_size, $disk_id, $file_entry_md5);
            }
    fclose($fp);
  }  
  
  
  function searchPC64($dir,$dir_entry,$md5hash)
  {
    global $DB;
    global $path;
    global $pack_id;
    global $pack_name;
    $filename = $path.$dir.$dir_entry;
   
    $disk_id = $DB->add_disk($dir_entry, ' unknown ', $pack_name.$dir, $pack_id, $md5hash);
    $filesize = ceil((filesize($filename)-26)/254);

    $fp = fopen($filename,'r');
    $c64_image = fread($fp,$filesize);    

		$c64_filename = substr($c64_image,8,18);
    $c64_filename = replace_bad_chars($c64_filename);

		$file_entry = substr($c64_image, 26, $filesize);
    $file_entry_md5 = md5($file_entry);
    fclose($fp);
    
    $c64_filetype = 'PRG(p00)';
    $DB->add_release($c64_filename, $c64_filetype, $filesize, $disk_id, $file_entry_md5);
  }  


  function searchPRG($dir,$dir_entry, $md5hash)
  {
    global $DB;
    global $path;
    global $pack_id;
    global $pack_name;  
    $filename = $path.$dir.$dir_entry;

    $disk_id = $DB->add_disk($dir_entry, ' unknown ', $pack_name.$dir, $pack_id, $md5hash);
    $filesize = ceil((filesize($filename))/254);
    $c64_filename = basename(str_replace('.prg','',$filename)); // remove .PRG extension
    $c64_filename = replace_bad_chars($c64_filename);
    $c64_filetype = 'PRG(prg)';
    $file_entry_md5 = $md5hash;
    $DB->add_release($c64_filename, $c64_filetype, $filesize, $disk_id, $file_entry_md5);
  }

  function searchCRT($dir,$dir_entry, $md5hash)
  {
    global $DB;
    global $path;
    global $pack_id;
    global $pack_name;  
    $filename = $path.$dir.$dir_entry;

    $disk_id = $DB->add_disk($dir_entry, ' unknown ', $pack_name.$dir, $pack_id, $md5hash);
    $filesize = ceil((filesize($filename))/254);
    $c64_filename = basename(str_replace('.crt','',$filename)); // remove .PRG extension
    $c64_filename = replace_bad_chars($c64_filename);
    $c64_filetype = 'CRT';
    $file_entry_md5 = $md5hash;
    $DB->add_release($c64_filename, $c64_filetype, $filesize, $disk_id, $file_entry_md5);
  }

  function searchG64($dir,$dir_entry, $md5hash)
  {
    global $DB;
    global $path;
    global $pack_id;
    global $pack_name;  
    $filename = $path.$dir.$dir_entry;

    $disk_id = $DB->add_disk($dir_entry, ' unknown ', $pack_name.$dir, $pack_id, $md5hash);
    $filesize = '';
    $c64_filename = basename(str_replace('.g64','',$filename)); // remove .PRG extension
    $c64_filename = replace_bad_chars($c64_filename);
    $c64_filetype = 'G64';
    $file_entry_md5 = $md5hash;
    $DB->add_release($c64_filename, $c64_filetype, $filesize, $disk_id, $file_entry_md5);
  }


  function searchTAP($dir,$dir_entry, $md5hash)
  {
    global $DB;
    global $path;
    global $pack_id;
    global $pack_name;  
    $filename = $path.$dir.$dir_entry;

    $disk_id = $DB->add_disk($dir_entry, ' unknown ', $pack_name.$dir, $pack_id, $md5hash);
    $filesize = '';
    $c64_filename = basename(str_replace('.tap','',$filename)); // remove .PRG extension
    $c64_filename = replace_bad_chars($c64_filename);
    $c64_filetype = 'TAP';
    $file_entry_md5 = $md5hash;
    $DB->add_release($c64_filename, $c64_filetype, $filesize, $disk_id, $file_entry_md5);
  }


  function searchUNK($dir, $dir_entry, $md5hash)
  {
    global $DB;
    global $path;
    global $pack_id;
    global $pack_name;  
    $filename = $path.$dir.$dir_entry;

    $disk_id = $DB->add_disk($dir_entry, ' unknown ', $pack_name.$dir, $pack_id, $md5hash);
    $filesize = ceil((filesize($filename)-26)/256);
    $c64_filename = $dir_entry; 
    $c64_filetype = 'UNK(prg)';

    $c64_filename = replace_bad_chars($c64_filename);
    $DB->add_release($c64_filename, $c64_filetype, $filesize, $disk_id, null);
  }  
  
  
  function zplit($str,$chr_val)
  {
   // takes a given string $str, and a char_value (0-255)
   // returns the (sub)string until first ord($str[$i])==$chr_val 
   $stop = false;$i= 0;$res = "";          
   while (!$stop)
   {
    $p = substr($str,$i,1);
    if (strcmp(ord($p),$chr_val)<>0) $res .= $p;
    else $stop = true;
    $i++;
    if ($i>strlen($str)) break;            
   }
   return $res;       
  }
  
  function searchLNX($dir,$dir_entry, $md5hash)
  {
    global $DB;
    global $path;
    global $pack_id;
    global $pack_name;  
    $filename = $path.$dir.$dir_entry;

    $fp = fopen($filename,'r');
    $file_size = filesize($filename);  
    $c64_image = fread($fp,$file_size);
    
    $dir_size = zplit(substr($c64_image,96,4), '20');
    $label = zplit(substr($c64_image,100,40), 13);
    $label = replace_bad_chars($label);

    $num_entries = trim(zplit(substr($c64_image,100+strlen($label)+2,4), '13'));
    $data_offset = $dir_size * 254; // binary data begins here

    $disk_id = $DB->add_disk($dir_entry, $label, $pack_name.$dir, $pack_id, $md5hash);    

    // Get dir elements          
    $dir_start = 100 + strlen($label) + strlen($num_entries) + 4;
    $offset = $dir_start;

    for($i=0;$i<$num_entries;$i++)
    {
       $c64_filename = zplit(substr($c64_image,$offset,16),13);    
       $offset = $offset + 16 + 1;
       $file_size_B = zplit(substr($c64_image,$offset,5),13);
       $offset = $offset + 1 + strlen($file_size_B);
       $lnx_type = zplit(substr($c64_image,$offset,6),13);
       if ($lnx_type=='P') {$c64_filetype = 'prg';}
       else if ($lnx_type=='S') {$c64_filetype = 'seq';}
       else if  ($lnx_type=='R') {$c64_filetype = 'rel';}
       else {$c64_filetype = 'unk';}

       $offset = $offset + 2;
       $LSU_byte = zplit(substr($c64_image,$offset,6),13); // last sector useage                

       $offset = $offset + 1 + strlen($LSU_byte);

			 $filesize  = (($file_size_B-1)*254)+$LSU_byte-1;
			 $filestart = $data_offset;
			 $fileend   = $filestart + $filesize;
			 
       $file_entry  = substr($c64_image, $filestart, $filesize);       
       $file_entry_md5 = md5($file_entry);

       $data_offset = $data_offset + $file_size_B*254;
 
       $c64_filename = replace_bad_chars($c64_filename);
       $DB->add_release($c64_filename, $c64_filetype, $file_size_B, $disk_id, $file_entry_md5);
    }
    fclose($fp);
  }  
  

  function searchdisk81($dir,$dir_entry, $md5hash)
  {
    global $DB;
    global $path;
    global $pack_id;
    global $pack_name;
    $disk_id = $DB->add_disk($dir_entry, ' unknown ', $pack_name.$dir, $pack_id, $md5hash);
    $filename = $path.$dir.$dir_entry;

    $fp = fopen($filename,'r');
    fseek($fp,400129); // (256*39*40)+(256*3)+1
    for($i=0;$i<296;$i++) //296
    {
      $track = ord(substr($entry,2,1));
      $sector = ord(substr($entry,3,1));
      if ( ($track>81)) {fclose($fp);return;}
      $entry = fread($fp,32);
           
      $c64_filetype = ord(substr($entry,1,1));
      switch ($c64_filetype) 
        {
          case 130: $c64_filetype = 'PRG';break; // $82             
          case 192: $c64_filetype = 'DEL';break; // 
          case 193: $c64_filetype = 'PRG';break; // 
          case 194: $c64_filetype = 'PRG';break; //            
          case 128: $c64_filetype = 'DEL';break; // $80
          case 129: $c64_filetype = 'SEQ';break; // $81
          case 131: $c64_filetype = 'USR';break; // $83
          case 132: $c64_filetype = 'REL';break; // $84
          case 0  : $c64_filetype = '*RM';break; // $00 Deleted file!
          default: $c64_filetype = 'UNK'; // Unknown              
        }

      if ($c64_filetype<>'UNK')
      {
        $c64_filename = substr($entry,4,16);
        $file_size = ord(substr($entry,29,1));
        $c64_filename = replace_bad_chars($c64_filename);

        $DB->add_release($c64_filename, $c64_filetype, $file_size, $disk_id, null);
      }
    }
    fclose($fp);
  }
  
function traversedir($path, $dir) 
  {
    global $DB;
    // global $reduntant;
    global $total_entries;
    global $imported_entries;
    global $pack_id;
    global $update_pack;
    $Lext = array("d64", "d81", "t64", "lnx", "p00", "prg", "zip");
    $k = 0;
    $dir_list = scandir($path.$dir);     
    for ($i=0;$i<sizeOf($dir_list);$i++)
    {
      $dir_entry = $dir_list[$i];
      if ($dir_entry != "." && $dir_entry != "..") 
      {
        if (is_dir($path.$dir.$dir_entry)) 
        {
          traversedir($path, $dir.$dir_entry.'/');
        }
        else if (is_file($path.$dir.$dir_entry)) 
        {
         $file_extension = strtolower(substr(strrchr($dir_entry,"."),1));
         if (in_array($file_extension, $Lext)) 
         {
          $total_entries += 1;
          // add only unique archives(d64, lnx,t64...)
          $filename = $path.$dir.$dir_entry;         
          $fp = fopen($filename,'r');
          $file_size = filesize($filename);  
          if ($file_size>0)
          {
          $c64_image = fread($fp,$file_size);
          fclose($fp);
          $md5hash = md5($c64_image);    
          if ((($DB->disk_md5_exist($md5hash, true, $pack_id))==0)) //  AND (false)
          {        
              $imported_entries += 1;
              switch($file_extension) 
              {
              case "d64": searchdisk($dir, $dir_entry, $md5hash); break;
              case "t64": searchtape($dir, $dir_entry, $md5hash); break;
              case "lnx": searchlnx($dir, $dir_entry, $md5hash);  break;
              case preg_match("#^p+[0-9]#", $file_extension)==true: searchPC64($dir, $dir_entry, $md5hash); break;
              case "prg": searchPRG($dir, $dir_entry, $md5hash);  break;
              case "d81": searchdisk81($dir, $dir_entry, $md5hash); break;
              case "crt": searchCRT($dir, $dir_entry, $md5hash);  break;              
              case "g64": searchG64($dir, $dir_entry, $md5hash);  break;              
              case "tap": searchTAP($dir, $dir_entry, $md5hash);  break;              
              // case "zip": searchzip($dir, $dir_entry, $md5hash); break;
              // case "" :   searchUNK($dir, $dir_entry);  break;
              default: ; // do nothing!
              }
            }
            else
            {
              if ($update_pack==false)
              {
                // Dont show this when updating a pack!
                $located_in_packs = $DB->get_packname_disk_md5($md5hash);
                $k++;
                $col = (($k%2)==0) ? " bgcolor=#eeeeee " : " bgcolor=#ffffff "; 
                // $reduntant .= 
                echo    "<tr $col ><td>".$filename."</td>
                                 <td>".$located_in_packs[0]['disk_reference'].$located_in_packs[0]['disk_name']."</td>
                                 <td>$md5hash</td>
                                 <td>";
                for ($j=0;$j<sizeOf($located_in_packs);$j++)
                {
                  echo $located_in_packs[$j]['pack_name']."<br>";
                }              
                echo "</td></tr>";
                ob_flush();flush();sleep(1);
              }            
            }
           }
          else
          {
            fclose($fp); // file_size==0, close file  
          }                 
         }
        }
        else
        {
          echo "Unknown type: ".$dir.$dir_list[$i]."<br>";
          ob_flush();flush();sleep(1);
        }
      }  
    } 
  }
  
  echo $html_end;
  ob_end_flush();
?>
