<?php
class DB {
   /* -------------------------------------------------------------------------- 
   		Connect/disconnect to Database!   
   ----------------------------------------------------------------------------- */     
   function DB() 
   {
       $this->host = "localhost";
       $this->db   = "spunk";
       $this->user = "root";
       $this->pass = ""; 
       $this->link = mysql_connect($this->host, $this->user, $this->pass);
       mysql_select_db($this->db);
       if (!$this->link)  {die('Error message: ' . mysql_error());}            
       $db_selected = mysql_select_db($this->db);
       if (!$db_selected)
       {
        $this->create_db_structure();
        $db_selected = mysql_select_db($this->db);
        if (!$db_selected){die('Error message: ' . mysql_error());}
       }
   }
   
   function close() 
   {
       mysql_close($this->link);
   }
   
   
   function create_db_structure()
   {
   $this->query(" CREATE DATABASE `spunk` DEFAULT CHARACTER SET latin1 COLLATE latin1_general_ci ");
   $this->query("USE spunk");   
   
   $this->query("CREATE TABLE `c64_disk` (
      `disk_id` int(11) NOT NULL auto_increment,
      `disk_md5` varchar(128) collate latin1_general_ci NOT NULL,
      `disk_label` varchar(24) collate latin1_general_ci NOT NULL default '',
      `disk_name` varchar(255) collate latin1_general_ci NOT NULL default '',
      `disk_comment` varchar(255) collate latin1_general_ci NOT NULL,
      `disk_reference` varchar(255) collate latin1_general_ci NOT NULL default '',
      `pack_id` int(11) NOT NULL default '0',
      PRIMARY KEY  (`disk_id`),
      KEY `pack_id` (`pack_id`),
      KEY `disk_md5` (`disk_md5`)
      ) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;");
   
   $this->query("
      CREATE TABLE `c64_file` (
      `file_id` int(11) NOT NULL auto_increment,
      `file_entry` varchar(24) collate latin1_general_ci NOT NULL default '',
      `file_entry_md5` varchar(128) collate latin1_general_ci NOT NULL,
      `file_type` varchar(6) collate latin1_general_ci NOT NULL default '',
      `file_size` int(3) NOT NULL default '0',
      `file_comment` varchar(100) collate latin1_general_ci NOT NULL default '',
      `disk_id` int(11) NOT NULL default '0',
      PRIMARY KEY  (`file_id`),
      KEY `file_entry` (`file_entry`,`file_type`,`file_size`,`disk_id`),
      KEY `file_entry_md5` (`file_entry_md5`)
      ) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci; ");

    $this->query("
      CREATE TABLE `c64_pack` (
      `pack_id` int(11) NOT NULL auto_increment,
      `pack_name` varchar(255) collate latin1_general_ci NOT NULL default '',
      `pack_total_files` int(11) NOT NULL,
      `pack_date` datetime NOT NULL default '0000-00-00 00:00:00',
      PRIMARY KEY  (`pack_id`)
      ) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci; ");
   
    $this->query("
      CREATE TABLE `c64_relation_pack_disk` (
      `pack_id` int(11) NOT NULL,
      `disk_md5` varchar(128) collate latin1_general_ci NOT NULL,
      KEY `pack_id` (`pack_id`),
      KEY `disk_md5` (`disk_md5`)
      ) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci; ");
   }

   function kill_spunk() 
   {
    $this->query(" DROP DATABASE spunk");
   }

   
   /* -------------------------------------------------------------------------- 
     Database Query commands   
   ----------------------------------------------------------------------------- */
   
   function query($query) 
   {
       $result = mysql_query($query, $this->link);
       if (!$result) {die('Invalid query: ' . mysql_error());}      
       return $result;
   }
   

   function num_results($query)
   {
    return mysql_num_rows($this->query($query));  	
   }
   
   
   /*
    *
    *  Search functions
    *
    */
   
   function get_file($file_id)
   {
    $query = " 
      SELECT F.*, D.*, P.*
      FROM c64_file as F
      LEFT JOIN c64_disk AS D ON D.disk_id=F.disk_id
      LEFT JOIN c64_pack AS P ON P.pack_id=D.pack_id
      WHERE file_id='$file_id' 
    ";
  	return mysql_fetch_array($this->query($query));
   }

   function retrieve_file($file_id, $path)
   {
    /* GET INTERNAL FILE FUNCTION */  
    $get_file = $this->get_file($file_id);
    $dname = $get_file['disk_name'];
    $ppath = $get_file['pack_reference'];
    $dpath = $get_file['disk_reference'];
    $file =  $path.$ppath.$dpath.$dname;
    
    if (file_exists($file))
    {
      header("Content-Disposition: attachment; filename=\"$dname\"");
      header("Content-Type: application/octetstream");
      header("Content-Length: ".filesize($file)); 
      header("Cache-Control: no-cache, must-revalidate"); 
      header("Pragma: no-cache");
  
      $fp = fopen($file,"r");
      if ($fp===false){echo "Error opening file: $file <br><br>Please contact admin! ";}
      else{ echo fread( $fp, filesize($file) ); fclose($fp); exit();}
    }
    else
    {
      echo "<h2>File does not exist! Please contact admin!</h2>".$file."<br>";  
    }
   }
   
    function retrieve_disk($disk_id, $path)
   {
    /* GET INTERNAL FILE FUNCTION */  
    $get_file = $this->get_disk2($disk_id);
    $dname = $get_file['disk_name'];
    $ppath = $get_file['pack_reference'];
    $dpath = $get_file['disk_reference'];
    $file =  $path.$ppath.$dpath.$dname;
    
    if (file_exists($file))
    {
      header("Content-Disposition: attachment; filename=\"$dname\"");
      header("Content-Type: application/octetstream");
      header("Content-Length: ".filesize($file)); 
      header("Cache-Control: no-cache, must-revalidate"); 
      header("Pragma: no-cache");
  
      $fp = fopen($file,"r");
      if ($fp===false){echo "Error opening file: $file <br><br>Please contact admin! ";}
      else{ echo fread( $fp, filesize($file) ); fclose($fp); exit();}
    }
    else
    {
      echo "<h2>File does not exist! Please contact admin!</h2>".$file."<br>";  
    }
   }
     
   function get_file_url($file_id)
   {
  	$file  = $this->get_file($file_id);
    return $file['pack_reference'].$file['disk_reference'].$file['disk_name'];
   }

   
   function get_disk($disk_id)
   {
    $query = " 
      SELECT D.*, P.*, F.file_id
      FROM c64_disk AS D
      LEFT JOIN c64_pack AS P ON P.pack_id=D.pack_id
      LEFT JOIN c64_file AS F ON F.disk_id=D.disk_id
      WHERE D.disk_id='$disk_id' AND F.disk_id='$disk_id'
      GROUP BY disk_id 
    ";
  	return mysql_fetch_array($this->query($query));
   }   
    
    
   function get_disk2($disk_id)
   {
    $query = " 
      SELECT D.*, P.*
      FROM c64_disk AS D
      LEFT JOIN c64_pack AS P ON P.pack_id=D.pack_id
      WHERE D.disk_id='$disk_id'
    ";
  	return mysql_fetch_array($this->query($query));
   }  

   
   function search($filename,$filetype=NULL,$filesize=NULL, $order=" ORDER BY file_entry ")
   {
    $filename = str_replace("%", "\\%", $filename);
    $filename = str_replace("", "%", $filename);
    $ftype="";
    if ($filetype){$ftype= " and file_type LIKE '$filetype' ";}
    if ($filesize){$ftype= " and file_size LIKE '$filesize' ";}  
    
    return $this->query(" 
      SELECT F.*, D.disk_name
      FROM c64_file as F
      LEFT JOIN c64_disk AS D ON D.disk_id=F.disk_id
      WHERE file_entry LIKE \"$filename\" $ftype $fsize $order ");  
   }   

   function search_label($label)
   {
      $label = str_replace("%", "\\%", $label);
      $label = str_replace("", "%", $label);
      return $this->query(" 
        SELECT D.*
        FROM c64_disk AS D
        WHERE disk_label LIKE \"$label\" ORDER BY disk_label ");  
   } 
   
   function add_pack($pname)
   {
    $query = " 
      INSERT INTO c64_pack (pack_name, pack_date)
      VALUE (\"$pname\", NOW());      
    ";
  	$this->query($query);
    $pid = mysql_insert_id();
    return $pid;     
   }

    
   function set_pack_files($number, $pack_id)
   {    
    // total number of c64 files in the pack (also redundant files...)
    $this->query(" UPDATE c64_pack SET pack_total_files=\"$number\" WHERE pack_id='$pack_id' ");    
   }
   
   
  function delete_pack($pack_id)
  {
    // Delete all file_entries on each disk
    $disks = $this->query(" SELECT disk_id FROM c64_disk as D WHERE pack_id='$pack_id' ORDER BY disk_id "); 	   
    $disk = mysql_fetch_array($disks);
    $start = $disk['disk_id'];
    $end   = $start;   
    while ($disk = mysql_fetch_array($disks))
  		  {
         if ($disk['disk_id']==($end+1)){$end++;}
         else
         {
             $this->query(" DELETE FROM c64_file WHERE disk_id>='$start' AND disk_id<='$end' ");
             $start=$disk['disk_id'];
             $end  =$start;
         }
        }
    $this->query(" DELETE FROM c64_file WHERE disk_id>='$start' AND disk_id<='$end' ");
    
    // Delete all disk in the pack
  	$this->query(" DELETE FROM c64_disk WHERE pack_id='$pack_id' ");
    // Delete relations pack<->disks
  	$this->query(" DELETE FROM c64_relation_pack_disk WHERE pack_id='$pack_id' ");        
    // Delete the pack
  	$pack_name = mysql_fetch_array($this->query(" SELECT * FROM c64_pack WHERE pack_id='$pack_id' "));        
  	$this->query(" DELETE FROM c64_pack WHERE pack_id='$pack_id' ");        
    return $pack_name['pack_name'];
  } 
   
  function delete_all_packs()
  {
  	$this->query(" TRUNCATE TABLE c64_disk "); 	
  	$this->query(" TRUNCATE TABLE c64_file "); 	
  	$this->query(" TRUNCATE TABLE c64_pack "); 	
  	$this->query(" TRUNCATE TABLE c64_relation_pack_disk "); 	
  }


  function pack_name_exists($pack_name)
  {   
    $query = " SELECT * FROM c64_pack as P WHERE pack_name='$pack_name' ";
    return mysql_fetch_array($this->query($query)); 
  }


  function get_packs($pack_id=NULL)
   {
    $pack = ($pack_id) ? " WHERE p.pack_id='$pack_id' " : "";
    $query = " 
      SELECT Count(*) AS 'numOfFiles', P.*
      FROM c64_pack as P
      LEFT JOIN c64_disk AS D ON D.pack_id=P.pack_id
      $pack
      GROUP BY pack_name
      ORDER BY pack_name 
    ";
  	return $this->query($query);
   }      
   
   
   function add_disk($dname, $dlabel, $dref, $pack_id, $md5)
   {
    $query = " 
      INSERT INTO c64_disk (disk_name, disk_label, disk_reference, pack_id, disk_md5)
      VALUE (\"$dname\", \"$dlabel\", \"$dref\", \"$pack_id\",  \"$md5\")      
    ";
   	$this->query($query);
    $disk_id = mysql_insert_id();

    $query = " 
      INSERT INTO c64_relation_pack_disk (pack_id, disk_md5)
      VALUE (\"$pack_id\",  \"$md5\")      
    ";
   	$this->query($query);

    return $disk_id;  
   }   
   

   function disk_md5_exist($md5hash, $add=NULL, $pack_id)
   {
    // add_counter is for statistical info. e.g. how many of current md5 
    // disk has been tried to be added. 
    $row = mysql_fetch_array($this->query("SELECT disk_id FROM c64_disk as D WHERE D.disk_md5='$md5hash'"));
    $disk_id = $row['disk_id'];
    if (($add) AND ($disk_id) ){
      $query = " 
        INSERT INTO c64_relation_pack_disk (pack_id, disk_md5)
        VALUE (\"$pack_id\",  \"$md5hash\")      
      ";
   	  $this->query($query);
    }    
  	return $disk_id; 
   }   


   function get_packname_disk_md5($md5hash)
   {
    $query = " 
      SELECT disk_reference, disk_name, pack_name
      FROM c64_relation_pack_disk AS RPD 
      LEFT JOIN c64_disk as D ON D.disk_md5=RPD.disk_md5
      LEFT JOIN c64_pack as P ON P.pack_id=RPD.pack_id
      WHERE D.disk_md5='$md5hash' 
      GROUP BY RPD.pack_id
    ";
    $result = $this->query($query);

  	$array = array();
  	while ($row = mysql_fetch_array($result))
  		{
  		 array_push($array,$row);
  		}  		
  	return $array;          
  }


  function get_file_from_disk_md5($md5hash, $file_entry)
   {
    $query = " 
      SELECT disk_name, F.* 
      FROM c64_disk AS D
      LEFT JOIN c64_file as F ON F.disk_id=D.disk_id
      WHERE D.disk_md5='$md5hash' AND file_entry LIKE \"%$file_entry%\"
    ";
    $result = $this->query($query);
    return mysql_fetch_array($result);
  }

   
   function add_release($fentry, $ftype, $fsize, $disk_id, $fmd5)
   {
    // only add file_entries with #chars>=2 that are [AZ-09]
    If (preg_match("/^[A-Z0-9]{2,}/",$fentry)) 
    {
    $add = true;
    if ($fmd5)
      {
        $row = mysql_fetch_array($this->query(" SELECT file_id FROM c64_file as F WHERE F.file_entry_md5='$fmd5' "));
        if ($row['file_id']) {$add = false;}
      }
      // Add release if fmd5=null or fmd5 does not exist.
      if ($add==true)
      {
        $query = " 
                  INSERT INTO c64_file (file_entry, file_entry_md5, file_type, file_size, disk_id)
                  VALUE (\"$fentry\", \"$fmd5\", \"$ftype\", \"$fsize\", \"$disk_id\")      
                 ";
  	    $this->query($query);
  	  }
  	}
   }  


   function update_file($fid, $comment)
   {
    if (is_numeric($fid))
    {
      $cmt = htmlentities($comment);
      $this->query(" UPDATE c64_file SET file_comment=\"$cmt\" WHERE file_id='$fid' ");    
  	}
   }

   
   
   // -------------------------------------------------------------------------
   // the END.   
   // -------------------------------------------------------------------------
} 
